Models/ErrorViewModel.cs
using System;

namespace Projet42.Models
{
    public class ErrorViewModel
    {
        public string RequestId { get; set; }

        public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
    }
}

Controllers/Api/RabbitController.cs
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace Projet42.Controllers.Api
{
    [Route("api/rabbit")]
    [ApiController]
    public class RabbitController : ControllerBase
    {
        [HttpPost("request")]
        public ActionResult<Boolean> RequestMQ()
        {
            Console.WriteLine("requestMQ");
            return true;
        }

        [HttpPost("response")]
        public ActionResult<Boolean> ResponseMQ()
        {
            Console.WriteLine("responseMQ");
            return true;
        }
    }
}

Controllers/HomeController.cs
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using Projet42.Models;
using Projet42.Utils;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;

namespace Projet42.Controllers
{
    public class HomeController : Controller
    {
        private readonly ILogger<HomeController> _logger;
        private string baseURL { get; set; }

        private void Init()
        {
            baseURL = (Request.IsHttps ? "https://" : "http://") + Request.Host;
        }

        public HomeController(ILogger<HomeController> logger)
        {
            _logger = logger;
        }
        
        public IActionResult Index()
        {
            Init();
            ViewData["BaseURL"] = baseURL;
            ViewBag.map = Request.Cookies["map"];
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}

Controllers/MapController.cs
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace Projet42.Controllers
{
    [Route("api/map")]
    [ApiController]
    public class RabbitController : ControllerBase
    {
        [HttpPost("defaultMap/{map}")]
        public ActionResult<Boolean> editDefaultMap(string map)
        {
            Response.Cookies.Append("map", map);
            return true;
        }
    }
}

Controllers/TestController.cs
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace Projet42.Controllers
{
    public class TestController : Controller
    {
        public IActionResult Index()
        {
            return View();
        }

        public IActionResult googlemaps()
        {
            return View();
        }

        public IActionResult openstreetmap()
        {
            return View();
        }
        public IActionResult MQDemo()
        {
            return View();
        }
        
    }
}

Views/Home/Index.cshtml
@{
    ViewData["Title"] = "Home Page";
}

<script src="~/lib/jquery/dist/jquery.min.js"></script>
<script>
    let waitForResult = false;
    $("#switchMap").change(function () {
        if (!waitForResult) {
            waitForResult = true;
            console.log($(this));
            let map = $(this).prop("checked") ? "OpenStreetMap" : "GoogleMaps";
            $.ajax({
                url: "@ViewData["BaseURL"]" + "/api/map/defaultMap/" + map,
                type: 'POST',
                success: function (result) {
                    document.location.reload();
                },
                error: function (result) {
                    console.log(result);
                },
                complete: function () {
                    waitForResult = false;
                }
            });
        };
    });
</script>

<span>@ViewBag.map</span>

@{ 
    if (ViewBag.map == "GoogleMaps")
    {
        Html.RenderPartial("~/Views/Home/maps/googlemaps.cshtml");
    } else
    {
        
    }
}

Views/Home/maps/googlemaps.cshtml
<div id="itineraire_container">
    <h1>Itinéraire</h1>
    <div class="itineraire_capture">
        <div class="itineraire_part">
            <span>Point de départ : </span>
            <input id="originAddress" type="text" placeholder="Sélectionner la destination de départ" /><br />
        </div>
        <div class="itineraire_part">
            <span>Point d'arrivée : </span>
            <input id="destinationAddress" type="text" placeholder="Sélectionner la destination d'arrivé" />
        </div>
        <div class="itineraire_part">
            <button id="calculItineraire" type="button">Voir l'itinéraire</button>
        </div>
    </div>
</div>

<div id="mapContainer">
    <div id="map"></div>
    <div id="modeDeplacement">
        <div id="typeEfficiency"></div>
        <div id="modeTransport"></div>
    </div>
    <div id="directionsPanel"></div>
</div>

<script src="~/js/maps/googlemaps/googlemaps.js"></script>
<script src="~/js/maps/googlemaps/map.js"></script>
<script async src="https://maps.googleapis.com/maps/api/js?key=AIzaSyBI9Ha6U7b2qNYHDs3NqtfH9sXMy4LjHI8&libraries=places&callback=initMap"></script>

Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - Projet42</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/switch.css" />
    <link rel="stylesheet" href="~/css/site.css" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">Projet42</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex justify-content-between">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Test" asp-action="Index">Tests Maps</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Test" asp-action="MQDemo">RabbitMQ</a>
                        </li>
                    </ul>
                </div>
                <div class="navbar-collapse collapse d-sm-inline-flex justify-content-between">
                    <ul class="navbar-nav ml-auto">
                        <li class="nav-item" style="width: 254px;">
                            <div class="can-toggle">
                                <input id="switchMap" type="checkbox" checked="@(ViewBag.map == "OpenStreetMap" ? true : false)">
                                <label for="switchMap">
                                    <div class="can-toggle__switch" data-checked="OpenStreetMap" data-unchecked="GoogleMaps"></div>
                                </label>
                            </div>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2021 - Projet42 - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @await RenderSectionAsync("Scripts", required: false)
</body>
</html>

Views/Test/Index.cshtml
@{
    ViewData["Title"] = "Home Page";
}

<a class="nav-link text-dark" asp-area="" asp-controller="Test" asp-action="googlemaps">Google Maps</a>
<a class="nav-link text-dark" asp-area="" asp-controller="Test" asp-action="openstreetmap">OpenStreetMap</a>

Views/Test/MQDemo.cshtml
@*
    For more information on enabling MVC for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860
*@
@{
}

<input type="text" id="testmsg"/>

<button id="demoMQ" type="submit">
    Submit
</button>

<div class="card">
    <div class="card-header">

    </div>

    <div class="card-body" id="mqResponse">

    </div>
</div>


<script>

    function sendRequestAjax() {
        $.ajax({
            type: "POST",
            data: $("#testmsg"),
            url: "api/rabbit/request",
            contentType: "application/text",
            Accept: "application/json, application/text, application/geo+json, application/gpx+xml, img/png; charset=utf-8"
        }).done(function (data) {
            $("#mqResponse").html(data);
        }).fail(function (e) { console.log(e); });
    }

    function WaitResponseAjax() {
        $.ajax({
            type: "POST",
            data: $("#testmsg"),
            url: "api/rabbit/response",
            contentType: "application/text",
            Accept: "application/json, application/text, application/geo+json, application/gpx+xml, img/png; charset=utf-8"
        }).done(function (data) {
            $("#mqResponse").html(data);
        }).fail(function (e) { console.log(e); });
    }

    $(document).ready(function () {
        $(document).("click", "#testmsg", function () {
            sendRequestAjax();
        });
    });
</script>

Views/Test/googlemaps.cshtml
<div id="itineraire_container">
    <h1>Itinéraire</h1>
    <div class="itineraire_capture">
        <div class="itineraire_part">
            <span>Point de départ : </span>
            <input id="originAddress" type="text" placeholder="Sélectionner la destination de départ" /><br />
        </div>
        <div class="itineraire_part">
            <span>Point d'arrivée : </span>
            <input id="destinationAddress" type="text" placeholder="Sélectionner la destination d'arrivé" />
        </div>
        <div class="itineraire_part">
            <button id="calculItineraire" type="button">Voir l'itinéraire</button>
        </div>
    </div>
</div>

<div id="mapContainer">
    <div id="map"></div>
    <div id="modeDeplacement">
        <div id="typeEfficiency"></div>
        <div id="modeTransport"></div>
    </div>
    <div id="directionsPanel"></div>
</div>

<script src="~/lib/jquery/dist/jquery.min.js"></script>
<script src="~/js/maps/googlemaps/googlemaps.js"></script>
<script src="~/js/maps/googlemaps/map.js"></script>
<script async src="https://maps.googleapis.com/maps/api/js?key=AIzaSyBI9Ha6U7b2qNYHDs3NqtfH9sXMy4LjHI8&libraries=places&callback=initMap"></script>

Views/Test/openstreetmap.cshtml
<link rel="stylesheet" href="~/css/leaflet.css" />
<script src="~/js/lib/leaflet.js"></script>

<style>
    #map {
        height: 600px;
    }
</style>

<div id="map"></div>

<script>
    var outdoorsthunderforest = L.tileLayer('https://{s}.tile.thunderforest.com/outdoors/{z}/{x}/{y}.png?apikey=af071baf070341ad86b5100adeec252b', {
        maxZoom: 20
    });

    var outdoorsopenstreetmap = L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
        maxZoom: 20
    });

    var hikebike = L.tileLayer('http://{s}.tiles.wmflabs.org/hikebike/{z}/{x}/{y}.png', {
        maxZoom: 20
    });
    var satellite = L.tileLayer('https://server.arcgisonline.com/ArcGIS/rest/services/World_Imagery/MapServer/tile/{z}/{y}/{x}', {
        maxZoom: 20
    });

    var map = L.map('map', {
        center: [0, 0],
        zoom: 2,
        layers: [outdoorsthunderforest],
        fullscreenControl: true
    });

    var baseLayers = {
        "outdoors (thunderforest.com)": outdoorsthunderforest,
        "outdoors (openstreetmap.org)": outdoorsopenstreetmap,
        "satellite": satellite,
        "hikebike": hikebike
    };

    L.control.layers(baseLayers).addTo(map);
</script>